#include <rover.h>

/*
straight(n) is forward motion, n is speed 
  n must be between -60 and 60
  
turnL(n) is left turn, n is speed 
  n must be between -60 and 60
  
turnR(n) is right turn, n is speed 
  n must be between -60 and 60

*/
//Pins below

// Treads
int left = 0 ;
int right = 2 ;
float call = 1;
float calr = .9;
int tog = 1;

//Other Pins
int lp = 4;
int rp = 1;
int tp = 3;

//Other
int maxs = 60;

// Setup, run once below.
void setup() {
  rover(left, right);
  pinMode(rp, INPUT);
  pinMode(lp, INPUT);
  pinMode(tp, INPUT);
  digitalWrite(tp, 1);
  digitalWrite(lp, 1);
  digitalWrite(rp, 1);
  cal(call,calr);
  start(); 
}

// the actual code:
void loop() {
  if(digitalRead(tp) == 0) {
    straight(-maxs);
  }
  else {
    if(digitalRead(lp) == 0) {
      if(digitalRead(rp) == 0) {
        straight(maxs);
      }
      else {
        rotate(maxs);
      }
    }
    else {
      if(digitalRead(rp) == 0) {
        rotate(-maxs);
      }
      else {
        straight(0);
      }
    }
  }
}

