#include <rover.h>

/*
straight(n) is forward motion, n is speed 
  n must be between -60 and 60
  
turnL(n) is left turn, n is speed 
  n must be between -60 and 60
  
turnR(n) is right turn, n is speed 
  n must be between -60 and 60

*/
//Pins below

// Treads
int left = 0 ;
int right = 2 ;
int call = 1;
int calr = 1;

//Other Pins
int lp = 1;
int pp = 4;
int buzzerpin = 3;

//Other
int times = 1000;
int fdtime1 = 1300;
int bstime1 = 200;
int bstime2 = 2000;
int thresh1 = 800;
int htime1 = 80;
int fdspeed1 = 60;
int bsspeed1 = 40;
int bsspeed2 = 60;
int tspeed1 = 55;
int ttime1 = 300;


// Setup, run once below.
void setup() {
  rover(left, right);
  pinMode(pp, INPUT);
  pinMode(lp, OUTPUT);
  pinMode(buzzerpin, OUTPUT);
  for(int x=0; x<=2; x++) {
    for (int fadeValue = 0 ; fadeValue <= 255; fadeValue += 5) {
      // sets the value (range from 0 to 255):
      analogWrite(lp, fadeValue);
      // wait for 30 milliseconds to see the dimming effect
      delay(30);
    }
    for (int fadeValue = 255 ; fadeValue >= 0; fadeValue -= 5) {
      // sets the value (range from 0 to 255):
      analogWrite(lp, fadeValue);
      // wait for 30 milliseconds to see the dimming effect
      delay(30);
    } 
  }
  cal(call,calr);
  start();
  backup(bsspeed2, buzzerpin, bstime2); 
}



// the actual code:
void loop() {
  headlights(lp, pp, thresh1);
  straight(fdspeed1);
  delay(fdtime1);
  straight(0);
  turnL(tspeed1);
  delay(ttime1);
  turnL(0);
  backup(bsspeed1, buzzerpin, bstime1); 
  headlights(lp, pp, thresh1);
  
}



void headlights(int lp,  int pp, int thresh) {
  int out = analogRead(pp);
  if(out < thresh) {
    digitalWrite(lp, 1);
  }
  else {
    digitalWrite(lp, 0);
  }
}

void backup(int speed1, int buzzerpin, int time) {
  straight( -speed1);
  for(int x = 0 ; x <= 20 ; x+=1) {
    delay(time/11);
    digitalWrite(buzzerpin, 1);
    delay(time/11);
    digitalWrite(buzzerpin, 0);
  }
  straight(0);
}

void honk(int time, int buzzerpin) {
  digitalWrite(buzzerpin, 1);
  delay(time);
  digitalWrite(buzzerpin, 0);
}
