#include <rover.h>

/*
straight(n) is forward motion, n is speed 
  n must be between -60 and 60
  
turnL(n) is left turn, n is speed 
  n must be between -60 and 60
  
turnR(n) is right turn, n is speed 
  n must be between -60 and 60

*/
//Pins below

// Treads
int left = 0 ;
int right = 2 ;

//Other Pins
int lp = 1;
int pp = 4;
int thresh = 500;

//Other
int times = 1000;


// Setup, run once below.
void setup() {
  rover(left, right);
  pinMode(pp, INPUT);
  pinMode(lp, OUTPUT);
  start();
}


void loop() {
  headlights(lp, pp, thresh);
  straight(60);
  delay(times);
  straight(-20);
  delay(times);
}

void headlights(int lp,  int pp, int thresh) {
  int knob = analogRead(pp);
  if(knob > thresh) {
    digitalWrite(lp, 0);
  }
  else {
    digitalWrite(lp, 1);
  }
}


